
#include <stdio.h>
#include <string.h>

// Defines
extern void initTestRun();
extern void disableInterrupt();
extern void enableInterrupt();

extern void invalidateICache( int size);
extern void invalidateDCache( int size);
extern void invalidateL2Cache( int size);

extern int ICacheMScan( int size);
// extern int ICacheMScan1( int size);
extern int DCacheMScan( int size);
extern int dcache_size();
extern int icache_size();


// extern void disableL2Bypass();
// extern void fillLockL2Line32 (unsigned int *data, unsigned int addr);
// extern void fillLockL2Line64 (unsigned int *data, unsigned int addr);
unsigned int myinst[8] = {0x21080100, 0x21080200,0x21080300,0x21080400,0x21080500,0x21080600,0x03e00008,0x00000000};
unsigned int myinst1[16] = {0x21080100, 0x21080200,0x21080300,0x21080400,0x21080500,0x21080600,0x21080700,0x21080800,
														0x21080900, 0x21080a00,0x21080b00,0x21080c00,0x21080d00,0x21080e00,0x03e00008,0x00000000};
void (*funcPtr)();

int ICresult = 0;
int DCresult = 0;

// Global variables.
volatile int num_cores;
volatile int vpe_on_core[4] ;
volatile int ready[8] ;
volatile int start_test[8] ;

void boston_lcd_display_byte_ab(unsigned int, char);

int main(unsigned int cpu_num, unsigned int core_num, unsigned int vpe_num, unsigned int num_vpe_this_core) {
	
    char display_char, blank;

    // Set Config.K0 to 2
	initTestRun();

	//disable Interrupt
	disableInterrupt();

    if (vpe_num == 0)
	{
    	// initialize the cache sub-system 1st before the test
    	invalidateICache(icache_size());
    	invalidateDCache(dcache_size());
    	invalidateL2Cache(512*1024);
	
	#if 0
		disableL2Bypass();
		fillLockL2Line64(myinst1, 0x01000000);
		funcPtr=0x81000000;
		funcPtr();

	#endif
	
	#if 1
		ICresult = ICacheMScan(icache_size());
		DCresult = DCacheMScan(dcache_size());
		if (ICresult || DCresult )
			boston_lcd_display_byte_ab(cpu_num, 'F');
		else
			boston_lcd_display_byte_ab(cpu_num, 'P');
	#endif

	//enable Interrupt
	enableInterrupt();
	}
	return 0;
}
